#version 300 es

//USE_LIGHT#define USE_LIGHT
//USE_SHADOW#define USE_SHADOW

uniform mat4 u_projMat;

#ifdef USE_SHADOW
uniform mat4 u_shadowMat;
#endif

layout(location = 0) in vec4 a_position;
layout(location = 1) in vec4 a_color;

out lowp vec4 v_color;

#ifdef USE_SHADOW
out mediump vec3  v_shadow;
#endif

#ifdef USE_LIGHT
out mediump float v_light;
#endif

void main()
{
    v_color = a_color;

#ifdef USE_LIGHT
    highp vec4 p = vec4(a_position.xyz, 1.);
    gl_Position  = u_projMat * p;
    v_light      = a_position.w;
    
#ifdef USE_SHADOW
    p        = u_shadowMat * p;
    v_shadow = p.xyz / p.w;
#endif

#else
    gl_Position = u_projMat * a_position;
#endif
}
