#version 300 es

//ANDROID#define ANDROID
//ATTRIB_MATRIX#define ATTRIB_MATRIX

// uniforms
#ifdef ANDROID
uniform vec4 u_mats[/U_MATS_SIZEx4/];
#else
uniform mat4 u_mats[/U_MATS_SIZE/];
#endif
uniform int  u_umatsPI;

// attributes
layout(location =  0) in vec4 a_position_i;
#ifdef ATTRIB_MATRIX
layout(location =  4) in mat4 a_mat1;
layout(location =  8) in mat4 a_mat2;
layout(location = 12) in mat4 a_mat3;
#else
layout(location =  4) in vec4 a_mat1_1;
layout(location =  5) in vec4 a_mat1_2;
layout(location =  6) in vec4 a_mat1_3;
layout(location =  7) in vec4 a_mat1_4;
layout(location =  8) in vec4 a_mat2_1;
layout(location =  9) in vec4 a_mat2_2;
layout(location = 10) in vec4 a_mat2_3;
layout(location = 11) in vec4 a_mat2_4;
layout(location = 12) in vec4 a_mat3_1;
layout(location = 13) in vec4 a_mat3_2;
layout(location = 14) in vec4 a_mat3_3;
layout(location = 15) in vec4 a_mat3_4;
#endif

void main()
{
    vec4 position = vec4(a_position_i.xyz, 1.);
    int  i        = int(a_position_i.w);
#ifdef ATTRIB_MATRIX
    if      (i == 0) gl_Position = a_mat1 * position;
    else if (i == 1) gl_Position = a_mat2 * position;
    else if (i == 2) gl_Position = a_mat3 * position;
#else
    if      (i == 0) gl_Position = mat4(a_mat1_1, a_mat1_2, a_mat1_3, a_mat1_4) * position;
    else if (i == 1) gl_Position = mat4(a_mat2_1, a_mat2_2, a_mat2_3, a_mat2_4) * position;
    else if (i == 2) gl_Position = mat4(a_mat3_1, a_mat3_2, a_mat3_3, a_mat3_4) * position;
#endif
    else
    {
    #ifdef ANDROID
        int j = (i - 3 + u_umatsPI * gl_InstanceID) << 2;
        gl_Position = mat4(u_mats[j++], u_mats[j++], u_mats[j++], u_mats[j]) * position;
    #else
        gl_Position = u_mats[i - 3 + u_umatsPI * gl_InstanceID] * position;
    #endif
    }
}
