#version 300 es
precision lowp float;

uniform lowp sampler2DShadow u_shadowTexture;
uniform lowp vec2 u_shadowTextureSize;
uniform float u_shadowVolume;

in lowp    vec4 v_color;
in mediump vec3 v_shadow;

out vec4 fragmentColor;

void main()
{
    vec3 v = v_shadow;
    v.z = clamp(v.z, 0., 1.);

    mediump float s = texture(u_shadowTexture, v);
    if (s == 0.)
    {
        vec2 sm = fract(v.xy * u_shadowTextureSize);
        if (sm.x > sm.y)
        {
            s  = textureOffset(u_shadowTexture, v, ivec2( 1,  0));
            s += textureOffset(u_shadowTexture, v, ivec2( 0, -1));
        }
        else
        {
            s  = textureOffset(u_shadowTexture, v, ivec2( -1, 0));
            s += textureOffset(u_shadowTexture, v, ivec2( 0,  1));
        }
        s = float(s == 2.f);
        
        if (s == 0.)
        {
            if (sm.x + sm.y < 1.)
            {
                s  = textureOffset(u_shadowTexture, v, ivec2( -1, 0));
                s += textureOffset(u_shadowTexture, v, ivec2( 0, -1));
            }
            else
            {
                s  = textureOffset(u_shadowTexture, v, ivec2( 1,  0));
                s += textureOffset(u_shadowTexture, v, ivec2( 0,  1));
            }
            s = float(s == 2.f);
        }
    }
    
    fragmentColor.rgb = vec3(0.);
    fragmentColor.a   = u_shadowVolume * (1. - s) * v_color.a;
}
