#version 300 es

uniform mat4 u_projMat;
uniform mat4 u_shadowMat;

layout(location = 0) in vec4 a_position;
layout(location = 1) in vec4 a_color;

out lowp    vec4 v_color;
out mediump vec3 v_shadow;

void main()
{
    gl_Position   = u_projMat * a_position;

    v_color       = a_color;
    
    vec4 position = u_shadowMat * a_position;
    v_shadow      = position.xyz / position.w;
}
